GMGenie.Macros.Whispers = {};

GMGenie.Macros.Whispers.curWhisperMessage = '';


function GMGenie.Macros.Whispers.run(name, title)
	GMMacros_Whispers_SubjectPopup:Hide();
	GMMacros_Whispers_SubjectPopup_Subject:SetText('');
	local msg = string.gsub(GMGenie_SavedVars.whispers[title], "NAME", name);
	if string.find(msg, "SUBJECT") then
		GMGenie.Macros.Whispers.curWhisperMessage = msg;
        GMGenie.Macros.Whispers.curName = name;
		GMMacros_Whispers_SubjectPopup:Show();
		GMMacros_Whispers_SubjectPopup_Subject:SetFocus();
	else
		args = {strsplit("\n",msg)};
		for index,text in pairs(args) do
			SendChatMessage(text, "WHISPER", nil, name);
		end
	end
end

function GMGenie.Macros.Whispers.runFromSpy()
    if GMSpy.currentRequest["name"] then
        GMGenie.Macros.Whispers.run(GMSpy.currentRequest["name"], this.value);
    end
end

function GMGenie.Macros.Whispers.sendWithSubject()
	GMMacros_Whispers_SubjectPopup:Hide();
	local subject = GMMacros_Whispers_SubjectPopup_Subject:GetText();
	GMMacros_Whispers_SubjectPopup_Subject:SetText('');
	
	local msg = string.gsub(GMGenie.Macros.Whispers.curWhisperMessage, "SUBJECT", subject);
	args = {strsplit("\n",msg)};
	for index,text in pairs(args) do
		SendChatMessage(text, "WHISPER", nil, GMGenie.Macros.Whispers.curName);
	end
	
	GMGenie.Macros.Whispers.curWhisperMessage = '';
end

function GMGenie.Macros.Whispers.addToUnitMenu()
    UnitPopupMenus["GMGenie_Whispers"] = {};
    
    local whispersTemp = GMGenie.pairsByKeys2(GMGenie_SavedVars.whispers);
    for index,name in pairs(whispersTemp) do
        table.insert(UnitPopupMenus["GMGenie_Whispers"], "GMGenie_Whispers_"..name);
        UnitPopupButtons["GMGenie_Whispers_"..name] = { text = name, dist = 0,};
    end
    
    table.insert(UnitPopupMenus["GMGenie_Whispers"], "GMGenie_WhisperOptions");
	UnitPopupButtons["GMGenie_WhisperOptions"] = { text = "Manage macros", dist = 0,};
end

function GMGenie.Macros.Whispers.loadDropdown(self, level)
    local info = UIDropDownMenu_CreateInfo();
    info.hasArrow = false;
    info.notCheckable = true;
    info.isTitle = true;
    info.text = "Whisper Macros";
    UIDropDownMenu_AddButton(info, level);
    
    local whispersTemp = GMGenie.pairsByKeys2(GMGenie_SavedVars.whispers);
    for index,name in pairs(whispersTemp) do
        local info = UIDropDownMenu_CreateInfo();
        info.hasArrow = false;
        info.notCheckable = true;
        info.text = name;
        info.func = GMGenie.Macros.Whispers.runFromSpy;
        info.value = name;
        UIDropDownMenu_AddButton(info, level);
    end
    
    local info = UIDropDownMenu_CreateInfo();
    info.hasArrow = false;
    info.notCheckable = true;
    info.text = "Manage Macros";
    info.func = GMGenie.Macros.Whispers.showOptions;
    UIDropDownMenu_AddButton(info, level);
end